{ String Grid Test Program Ver. 1 ( Delphi 1 )
  Copyright 1996 by Gary Rinsem
  garyrin@futureone.com

Intended to Allow the user to create, edit, and save the contents of a
string grid.  This code represents all I could learn about string grids
in 3 or 4 hours.  (OK, so I'm a little slow on the uptake)

Grid content is saved via ini file routines, and consequently the size
is limited to 64k.  Should be ok for many uses.  I included a sample
ini file, it belongs in the same directory as the exe file.  Just extract
the entire zip contents to it's own directory and open the project,
compile with "build all" and it should run.

If you like this program, send me e-mail!  If you've made improvements
you're proud of, then send that also.  If you hate this program, send
me e-mail!  If you've made improvements you're embarrassed by, then
absolutely send it. Everybody needs a good laugh Sometimes!!!!

I considered doing calculations based on values in cells, allowing file
selection (expand the data capacity) or formatting and printing, or.....?

I always appreciate Delphi 1 code.

Disclaimer:
This code is offered as Freeware.  I make no warranties, explicit or
implied.  If there are problems or if you break it, you're on your own,
if it causes eye strain, or WW III, or anything in between, you must
accept all responsibility. Otherwise, run to your nearest file manager
and delete all the files you got from me.

Provided in the true nursery school spirit of sharing, this is my first
attempt at doing that with code, I'll see how it works out. }

unit Unit1;

interface

uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
 IniFiles, Forms, Dialogs, StdCtrls, ExtCtrls, Grids, Menus;

type
 TForm1 = class(TForm)
 Panel1: TPanel;
 Edit1: TEdit;
 Grid1: TStringGrid;
 MainMenu1: TMainMenu;
 File1: TMenuItem;
 Open1: TMenuItem;
 Save1: TMenuItem;
 Exit1: TMenuItem;
 N1: TMenuItem;
 Panel2: TPanel;
 Add1: TMenuItem;
 AddRow1: TMenuItem;
 AddColumn1: TMenuItem;
 N2: TMenuItem;
 AdjustColumns1: TMenuItem;
 Edit2: TMenuItem;
 Window1: TMenuItem;
 About1: TMenuItem;
 N3: TMenuItem;
 EditTitles1: TMenuItem;
 SaveTitles1: TMenuItem;
 Label1: TLabel;
 Label2: TLabel;
 Delete1: TMenuItem;
 DeleteRow1: TMenuItem;
 DeleteColumn1: TMenuItem;
 N4: TMenuItem;
 HowToDelete1: TMenuItem;
 HowToAdd1: TMenuItem;
 procedure FormCreate(Sender: TObject);
 procedure SetFixedClick(Sender: TObject);
 procedure Open1Click(Sender: TObject);
 procedure Save1Click(Sender: TObject);
 procedure Exit1Click(Sender: TObject);
 procedure AddRow1Click(Sender: TObject);
 procedure AddColumn1Click(Sender: TObject);
 procedure AdjustColumns1Click(Sender: TObject);
 procedure About1Click(Sender: TObject);
 procedure EditTitles1Click(Sender: TObject);
 procedure HowToDelete1Click(Sender: TObject);
 procedure HowToAdd1Click(Sender: TObject);
 procedure DeleteRow1Click(Sender: TObject);
 procedure DeleteColumn1Click(Sender: TObject);

private
 IniFile: TIniFile;

end;

var Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject); begin
{ The grid will probably need as much width as it can get }
 Width := Screen.Width;
{ Use the path and exe.name with .ini extension }
 IniFile := TIniFile.Create(ChangeFileExt(ParamStr(0),'.INI'));
{ Put something into the ini file, will test if drive can be saved to,
  better than spending an hour adding data only to find out you can't
  save it (I know, using the Win dir should avoid the prob, but then
  you would have to move the ini sample file to use it) }
 IniFile.WriteString ('Title', 'Credit ', ' Gary''s String Grid Test Program'); end;

procedure TForm1.Exit1Click(Sender: TObject); begin
{ Bye }
 Close; end;

procedure TForm1.About1Click(Sender: TObject); begin
 ShowMessage('Jus'' Playin aRoun'); end;

procedure TForm1.SetFixedClick(Sender: TObject); begin
{ Sets the top col and left row to a fixed, button-like look }
 if (Grid1.RowCount > 1) and (Grid1.FixedRows < 1) then Grid1.FixedRows := 1;
 if (Grid1.ColCount > 1) and (Grid1.FixedCols < 1) then Grid1.FixedCols := 1; end;

procedure TForm1.EditTitles1Click(Sender: TObject); begin
{ Undo for the procedure above, let's the user edit the titles }
 Grid1.FixedRows := 0;
 Grid1.FixedCols := 0; end;

procedure TForm1.Open1Click(Sender: TObject);
 var I, I2:Integer; begin
{ Reads num of cols and rows from inifile and adjusts the grid to match }
 Grid1.ColCount := IniFile.ReadInteger ('Grid', 'Col', Grid1.ColCount);
 Grid1.RowCount := IniFile.ReadInteger ('Grid', 'Row', Grid1.RowCount);
{ for loop repeates the nested for loop once for each column }
 for I := 0 to Grid1.ColCount - 1 do begin
{ for loop wich reads each cell content }
  for I2 := 0 to Grid1.RowCount - 1 do begin
  Grid1.Cells[I, I2] := IniFile.ReadString (IntToStr(I2), IntToStr(I), Grid1.Cells[I, I2]);
 end;
{ set cell 0, 0 to indicate the filename }
 Grid1.Cells[0, 0] := ExtractFileName(IniFile.FileName);
{ set the titles to a button look }
 SetFixedClick(Self);
{ make all the text in each cell visible }
 AdjustColumns1Click(Self); end; end;

{ does the opposite of above (sorta) }
procedure TForm1.Save1Click(Sender: TObject);
 var I, I2:Integer; begin
 IniFile.WriteInteger ('Grid', 'Col', Grid1.ColCount);
 IniFile.WriteInteger ('Grid', 'Row', Grid1.RowCount);
 for I := 0 to Grid1.ColCount - 1 do begin
  for I2 := 0 to Grid1.RowCount - 1 do begin
  IniFile.WriteString (IntToStr(I2), IntToStr(I), Grid1.Cells[I, I2]); end; end; end;

{ adds a row if a title has been entered }
procedure TForm1.AddRow1Click(Sender: TObject); begin
if Edit1.Text <> '' then begin
 Grid1.RowCount := Grid1.RowCount + 1;
 Grid1.Cells[0, Grid1.RowCount - 1] := Edit1.Text;
 SetFixedClick(Self);
 AdjustColumns1Click(Self);
 Edit1.Clear; end else begin
 ShowMessage('You Must Enter a Caption');
 Edit1.SetFocus; end; end;

{ adds a col if a title has been entered }
procedure TForm1.AddColumn1Click(Sender: TObject); begin
if Edit1.Text <> '' then begin
 Grid1.ColCount := Grid1.ColCount + 1;
 Grid1.Cells[Grid1.ColCount - 1, 0] := Edit1.Text;
 SetFixedClick(Self);
 AdjustColumns1Click(Self);
 Edit1.Clear; end else begin
 ShowMessage('You Must Enter a Caption');
 Edit1.SetFocus; end; end;

{ make all the text in each cell visible }
procedure TForm1.AdjustColumns1Click(Sender: TObject);
 var I, I2: Integer; begin
{ for each grid column do the following }
 for I := 0 to Grid1.ColCount - 1 do begin
{ set the column width to the column title width + 5, makes sure the width
  is changed, in case the user left it wider than needed }
  Grid1.ColWidths[I] := (Grid1.Canvas.TextWidth(Grid1.Cells[I, 0]) + 5);
{ for the current column (column # I), go down the rows and adjust the
  col width if it's smaller than the cell text width + 5 }
  for I2 := 0 to Grid1.RowCount - 1 do begin
  if (Grid1.Canvas.TextWidth(Grid1.Cells[I, I2])) > Grid1.ColWidths[I] then
  Grid1.ColWidths[I] := (Grid1.Canvas.TextWidth(Grid1.Cells[I, I2])) + 5; end; end; end;

procedure TForm1.HowToDelete1Click(Sender: TObject); begin
 ShowMessage('Move the Row or Column to the end.  Press Delete (row or column)'); end;

procedure TForm1.HowToAdd1Click(Sender: TObject); begin
 ShowMessage('Type the title for the new row or column.  Press Add (row or column)'); end;

procedure TForm1.DeleteRow1Click(Sender: TObject); begin
{ ask the user for confirmation before deleting }
 if MessageDlg('Are You Sure You Want to DELETE the Row' +
{ line feed & carriage return + row title }
    #10#13 + '"' + Grid1.Cells[0, Grid1.RowCount - 1] + '"',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
{ remove the last row }
 Grid1.RowCount := Grid1.RowCount - 1; end;

procedure TForm1.DeleteColumn1Click(Sender: TObject); begin
{ ask the user for confirmation before deleting }
 if MessageDlg('Are You Sure You Want to DELETE the Column' +
{ line feed & carriage return + Col title }
    #10#13 + '"' +  Grid1.Cells[Grid1.ColCount - 1, 0] + '"',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
{ remove the last column }
 Grid1.ColCount := Grid1.ColCount - 1; end;

end.

